"""MOUNT FILE DIALOG"""
import sys, gtk, os, gobject, popup, util, texpect, uiutil, truecryptResponse, config, os
import volume, volumes

class Mount:
    "Mount Functions"
    
    "TRUECRYPT COMMAND LINE OPTIONS"
#    password = ""
#    mount_path = ""
    device = ""
    filesystem = "auto"
    mountoptions = ""
    
    protect_hidden = False
    read_only = False
    usermount = False
    update_time = False
    display_password = False
    
    device_number = 0

    conf= config.Config()
    "GUI OPTIONS"
    show_only_usual_filesystems= True
    visible= True
    "GUI MEMBERS"
    mounting_successful_pattern = "Mapped.*as.*\n.*Mounted.*at.*"

    path = os.path.abspath(sys.path[0])
    
    options_list = [protect_hidden, read_only, usermount, update_time, display_password]
    man_mount_filesystems = [ 'auto',  'adfs', 'affs', 'autofs', ' coda', 'coherent', 'cramfs',
                                'devpts',  'efs', 'ext', 'ext2', 'ext3', 'hfs', 'hpfs',
                                'iso9660', 'jfs', 'minix', 'msdos', 'ncpfs', 'nfs', 'nfs4',
                                'ntfs', 'proc', 'qnx4', 'ramfs', 'reiserfs', 'romfs',
                                'smbfs', 'sysv', 'tmpfs', 'udf', 'ufs', 'umsdos', 'usbfs',
                                'vfat', 'xenix', 'xfs', 'xiafs']
    
    
    def __init__(self,trayApp=None, volume=None, mount_directory=None):
        self.trayApp= trayApp
        self.conf= config.Config()

        self.gladefile=config.DIR_UI+"/dialogMount.glade" 
        self.wtree=gtk.glade.XML(self.gladefile)
        self.window = self.wtree.get_widget("mountWindow")
        
        self.wprotect_hidden= self.wtree.get_widget('protect_hidden')
        self.wread_only= self.wtree.get_widget('read_only')
        self.wuser_mount= self.wtree.get_widget('user_mount')
        self.wupdate_time= self.wtree.get_widget('update_time')
        self.wdisplay_password= self.wtree.get_widget('display_password')
        self.wvolume = self.wtree.get_widget('volume_path')
        self.wmount_directory= self.wtree.get_widget('mount_directory')
        self.wfilesystem= self.wtree.get_widget('filesystem')
        #self.wdevice_number= self.wtree.get_widget('device_number')
        self.wmount_options= self.wtree.get_widget('mountOptions')
        self.wpassword= self.wtree.get_widget('password')
        self.wfiles= self.wtree.get_widget('files')
        
        self.wchoose_path= self.wtree.get_widget('choosePath')
        
        self.liststore = gtk.ListStore(str)
        self.treeview= self.wfiles
        self.treeview.get_selection().set_mode(gtk.SELECTION_MULTIPLE)
        self.treeview.set_model(self.liststore)
        self.cell = gtk.CellRendererText()

        # create the TreeViewColumns to display the data
        self.tvcolumn = gtk.TreeViewColumn('File', self.cell, text=0)

        # add columns to treeview
        self.treeview.append_column(self.tvcolumn)
        self.treeview.set_search_column(0)

        # Allow sorting on the column
        self.tvcolumn.set_sort_column_id(0)

        # Allow enable drag and drop of rows including row move
        self.treeview.enable_model_drag_source( gtk.gdk.BUTTON1_MASK,
                                                uiutil.TARGETS,
                                                gtk.gdk.ACTION_DEFAULT|
                                                gtk.gdk.ACTION_MOVE)
        self.treeview.enable_model_drag_dest(uiutil.TARGETS,
                                             gtk.gdk.ACTION_DEFAULT)
        
        dic = {
               "on_file_selection_drag_drop" : self.handle_add_file,
               "on_close_clicked" : self.handle_close_clicked,
               "on_mountWindow_destroy" : self.handle_close_clicked,
               "on_mount_clicked" : self.handle_mount_clicked,
               "on_protect_hidden_toggled" : self.handle_button_toggeled,
               "on_read_only_toggled" : self.handle_button_toggeled,
               "on_user_mount_toggled" : self.handle_button_toggeled,
               "on_update_time_toggled" : self.handle_button_toggeled,
               "on_display_password_toggled" : self.handle_button_toggeled,
               "on_filesystem_changed" : self.handle_fs_changed,
               "on_mountOptions_changed": self.handle_mountOptions_changed,
               "on_files_drag_data_received" : uiutil.drag_data_received_data,
               "on_files_drag_data_get" : uiutil.drag_data_get_data,
               "on_clear_selected_clicked": self.clear_selected,
               "on_clear_all_clicked" : self.clear_all,
               "on_volume_path_changed": self.handle_vpath_changed,
               "on_add_keyfile_clicked": self.keyfiles_chooser,
               "on_choosePath_selection_changed" : self.filepath_choosed,
               "on_add_path_clicked" : self.keyfiles_chooser
               }
        self.wtree.signal_autoconnect(dic)
        self.set_init_options(volume, mount_directory)        
    
    def filepath_choosed(self, w):
        uri = self.wchoose_path.get_uri()
        if uri == None:
            return
        
        uri= util.get_filepath_from_uri(uri)
        if uri == self.wvolume.get_active_text():
            return
        
        volume_list= self.get_volume_list()
        if uri not in volume_list:
            self.set_volume(uri)
        else:
            for x in range(len(volume_list)):
                if volume_list[x] == uri:
                    self.wvolume.set_active(x)
                    self.set_mpoint_accordingly(uri)
                    self.set_options_accordingly(uri)

        
    def keyfiles_chooser(self, w):
        choosePath= False
        if w.get_name() == "add_path":
            choosePath= True
        keyfile, response= uiutil.KeyfilesChooser(choosePath).run()
        if response != gtk.RESPONSE_CANCEL:
            self.treeview.get_model().append([keyfile])

   
    def clear_all(self, b):
        "Clears the all the keyfiles"
        gtk.ListStore.clear(self.liststore)
    
    
    def clear_selected(self, button):
        "Clears the selected keyfile"
        selection = self.treeview.get_selection()
        model, selected = selection.get_selected_rows()
        iters = [model.get_iter(path) for path in selected]
        for iter in iters:
            model.remove(iter)
 
    def set_init_options(self, volume=None, mount_directory=None):
        "Set values"
        
        "Set active options"
        self.wprotect_hidden.set_active(util.if_else_bool(self.protect_hidden))
        self.wread_only.set_active(util.if_else_bool(self.read_only))
        self.wuser_mount.set_active(util.if_else_bool(self.usermount))
        self.wupdate_time.set_active(util.if_else_bool(self.update_time))
        self.wdisplay_password.set_active(util.if_else_bool(self.display_password))
        
        if self.show_only_usual_filesystems:
            for fs in config.MOUNT_FILESYSTEMS:
                self.wfilesystem.append_text(fs)
        else:
            for fs in self.man_mount_filesystems:
                self.wfilesystem.append_text(fs) 
        
        self.wfilesystem.set_active(0)
        
        #self.wdevice_number.set_value(self.device_number)
        
        self.window.set_icon_from_file(uiutil.ICON_PATH)
        
        "Insert history"
        if self.conf.iWantHistoryCaching():
            saved_file_volumes= self.trayApp.volumes_obj.get_saved_file_volumes()
            
            for s_vol in saved_file_volumes:
                self.wvolume.append_text(s_vol.volume_path)
                self.wmount_directory.append_text(s_vol.mount_point)
                
            saved_device_volumes= self.trayApp.volumes_obj.get_saved_and_present_device_volumes()
            for d_vol in saved_device_volumes:
                self.wvolume.append_text(d_vol.volume_path)
                self.wmount_directory.append_text(d_vol.mount_point)

            if volume!=None and volume not in self.get_volume_list():
                self.wvolume.insert_text(0, volume)
                self.wvolume.set_active(0)
                #self.set_mpoint_accordingly(volume)
            else:
                self.wvolume.set_active(0)
                self.wmount_directory.set_active(0)
                
            if mount_directory!=None:
                self.wmount_directory.append_text(mount_directory)
            

    def handle_button_toggeled(self, w):
        wname = w.get_name()
        if wname == "protect_hidden":
            self.protect_hidden = not(self.protect_hidden)
        elif wname == "read_only":
            self.read_only = not(self.read_only)
        elif wname == "user_mount":
            self.usermount = not(self.usermount)
        elif wname == "update_time":
            self.update_time = not(self.update_time)
        elif wname == "display_password":
            self.display_password = not(self.display_password)
            self.wpassword.set_visibility(not(self.wpassword.get_visibility()))
        else:
            ""
        
    def handle_close_clicked(self, w):
        self.hide()
        
    def show(self):
        self.visible=True
        self.window.show()
        
    def hide(self):
        self.visible=False
        self.window.hide()
        
    def isvisible(self):
        return self.visible
        
    def run(self):
        self.show_all()
    
    def handle_add_file(self, w, d):
        ""

    def on_activate_password(self, w):
        self.password = w.get_text()
    
    def get_volume_list(self):
        "this is such a shit can they not simply give me a array a list or whatever???!"
        volumes= []
        
        wmodel= self.wvolume.get_model()
        iter= wmodel.get_iter_first()
    
        while iter!= None:
            volumes.append(wmodel.get_value(iter, 0))
            iter= wmodel.iter_next(iter)
            
        return volumes
    
    def get_mount_point_list(self):
        mps= []
        
        wmodel= self.wmount_directory.get_model()
        iter= wmodel.get_iter_first()
    
        while iter!= None:
            mps.append(wmodel.get_value(iter, 0))
            iter= wmodel.iter_next(iter)
            
        return mps
    
    def get_mp_and_v(self):
        mps=  self.get_mount_point_list()
        vols= self.get_volume_list()
        return vols, mps
        
    def set_volume(self, vol):
        self.wvolume.insert_text(0,vol)
        self.wvolume.set_active(0)
        self.handle_vpath_changed(self.wvolume)
    
    def set_mount_point(self, mp):
        self.wmount_directory.insert_text(0, mp)
        self.wmount_directory.set_active(0)
          
          
    def handle_vpath_changed(self, w):
        active_vol= w.get_active_text()
        v = self.trayApp.volumes_obj.by_udi(active_vol)
        if v== False:
            v= self.trayApp.volumes_obj.by_volume_path(active_vol)
        if v==False:
            return
        self.set_mpoint_accordingly(v)
        self.set_options_accordingly(v)
                    
    
    def set_mpoint_accordingly(self, v):

        if v== False or v.mount_point == False:
            ""
        else:
            mlist= self.get_mount_point_list()
            for i in range(len(mlist)):
                if v.mount_point == mlist[i]:
                    self.wmount_directory.set_active(i)
                    return
                
            self.wmount_directory.insert_text(0, v.mount_point)
            self.wmount_directory.set_active(0)
            
    def set_options_accordingly(self, v):
        if v == False:
            ""
        
        options = v.options
        
        self.wprotect_hidden.set_active(options['protect_hidden'])
        self.wread_only.set_active(options['read_only'])
        self.wuser_mount.set_active(options['user_mount'])
        self.wupdate_time.set_active(options['update_time'])
        
        model= self.wfilesystem.get_model()
        iter = model.get_iter_first()
        i= 0
        while iter != None:
            value= model.get_value(iter, 0)
            
            if value == options['filesystem']:
                self.wfilesystem.set_active(i)
            i= i+1
            iter= model.iter_next(iter)

        self.wmount_options.set_text(options['mount_options'])
            
    def handle_mount_directory_changed(self, w=None, d=None):
        self.mount_path= w.get_active_text()

    def clear_history(self):
        "clears gui history"
        # attention, order matters
        self.wvolume.insert_text(0, "")
        self.wvolume.set_active(0)
        self.wvolume.get_model().clear()
        
        self.wmount_directory.insert_text(0, "")
        self.wmount_directory.set_active(0)
        self.wmount_directory.get_model().clear()
        self.wpassword.set_text("") #not so safe
        
    
    def handle_fs_changed(self, w=None, d=None):
        self.filesystem = w.get_active_text()
        
    def handle_mountOptions_changed(self, w):
        self.mountoptions = w.get_text()
    
    def handle_mount_clicked(self, w):
        keyfiles = uiutil.get_list_of_treemodel(self.liststore)
        #TODO: keyfiles for hidden volume error handling
        #check if hidden works
        if self.wpassword.get_text() == "" and len(keyfiles) == 0:
            popup.Popup(_("No Password given"))
            return
        
        elif self.wmount_directory.get_active_text() == "":
            popup.Popup(_("No mount point given"))
            return
            ""
        else:    
            
            if self.protect_hidden:
                pass_hidden_result, hidden_password= uiutil.PasswordDialog(_("Password for hidden volume "), "Please enter password").run()
                keyfiles_hidden_result, listkeyfiles= uiutil.EnterKeyfiles().run()
                hidden_keyfiles = uiutil.get_list_of_treemodel( listkeyfiles)
            else:
                hidden_password = None
                hidden_keyfiles = None
                
            options= {'user_mount': self.usermount,
                      'read_only':self.read_only,
                      'update_time': self.update_time,
                      'protect_hidden': self.protect_hidden,
                      'mount_options': self.mountoptions,
                      'filesystem': self.filesystem
                      }

            result= util.createMountPoint(self.wmount_directory.get_active_text())
            if not result:
                popup.Popup(_("The entered sudo password was wrong."))
                return
            if result == truecryptResponse.CANCELED:
                return
                        
            v= volume.Volume(self.wvolume.get_active_text(), self.wmount_directory.get_active_text(), options=options)
            exitCode= v.mount(self.wmount_directory.get_active_text(),
                                self.protect_hidden, keyfiles,
                                self.wpassword.get_text(),
                                hidden_password, hidden_keyfiles
                                )

            if exitCode == truecryptResponse.CANCELED:
                return
            if exitCode == truecryptResponse.VOLUME_MOUNTED:
                if self.conf.iWantHistoryCaching():
                    v.add_to_gconf()
 
                if self.trayApp != None:
                    self.trayApp.refreshList()
                    
                self.trayApp.tlist.hide()
                self.hide()
                try:
                    after_command= self.conf.get(config.AFTER_MOUNT_COMMAND)
                    after_command= after_command.replace("%s", self.wmount_directory.get_active_text())
                    os.system(after_command)
                except:
                    ""
                
            elif exitCode == truecryptResponse.TRY_AGAIN:
                popup.Popup(_("Wrong sudo password"))
                 
            elif exitCode == truecryptResponse.WRONG_FS_TYPE:
                popup.Popup(_("Volume could not be mounted! This maybe because you selected user mount for a unix filesystem. Unmount volume and mount again without the user mount option"))
            
            elif exitCode == truecryptResponse.ALREADY_MAPPED:
                popup.Popup(_("Volume already mapped!"))
            
            elif exitCode == truecryptResponse.CANNOT_OPEN_VOLUME:
                popup.Popup(_("Cannot open volume: No such file"))

            elif exitCode == truecryptResponse.KEYFILE_DOES_NOT_EXIST:
                popup.Popup(_("Keyfile(s) do(es) not exist"))
                
            elif exitCode == truecryptResponse.ILLEGAL_SEEK:
                popup.Popup(_("Illegal Seek: This is not good, the volume might be corrupted "))
        
            elif exitCode == truecryptResponse.MOUNT_POINT_DOES_NOT_EXIST:

                "Truecrypt does not mount it but it sets the dev mapper device up \
                so we have to dismap it after getting a mount point does not exist"
                result = v.unmount()
                if result== truecryptResponse.TRY_AGAIN:
                    popup.Popup(_("Want to unmap volume because mountpoint does no exist. Wrong sudo password"))
                else:
                    popup.Popup(_("Mount point does not exist"))

                
            elif exitCode == truecryptResponse.INCORRECT_VOLUME:
                popup.Popup(_("Sorry wrong password/keyfiles or not a truecrypt volume"))

            else:
                popup.Popup(_("Unknown exit code: Contact developer forcefield@bockcay.de"))
                #TODO_: CONTACT DIALOG"
        
if __name__ == "__main__":
    hwg = Mount()
    gtk.main()