import sys, gtk, os, util, uiutil, config, gobject
    
class Properties:

    visible= True
    def __init__(self, trayApp= None, mounted=None):
        self.trayApp= trayApp
        #self.conf= self.trayApp.conf
        self.conf= config.Config()
        
        
        self.gladefile=config.DIR_UI+"/dialogProperties.glade" 
        self.wtree=gtk.glade.XML(self.gladefile)
        self.window = self.wtree.get_widget("propertiesWindow")
        self.window.set_icon_from_file(uiutil.ICON_PATH)

        self.enterSuspend= self.wtree.get_widget("enterSuspend")
        self.enterSuspend.set_active(self.conf.get(config.DISMOUNT_ON_SUSPEND))

        self.logOff= self.wtree.get_widget("userLogsOff")
        self.logOff.set_active(self.conf.get(config.DISMOUNT_ON_LOGOFF))
        
        self.screensaverLauch= self.wtree.get_widget("screensaverIsLaunched")
        self.screensaverLauch.set_active(self.conf.get(config.DISMOUNT_ON_SCREENSAVER))
        
        self.bg = self.wtree.get_widget("bgstart")
        self.bg.set_active(self.conf.get(config.BACKGROUND))
        
        self.history = self.wtree.get_widget("activeHistory")
        self.history.set_active(self.conf.get(config.CACHE_HISTORY))
        
        aftermountCommand= self.conf.get(config.AFTER_MOUNT_COMMAND)
        self.openCommands= self.wtree.get_widget("openVolume")
        self.openCommands.set_text(aftermountCommand)

        self.suid_rights= self.wtree.get_widget("suid_rights")
        self.suid_rights.set_active(util.userInForcefieldGroup())
              
        self.ok= self.wtree.get_widget("okButton")
        self.cancel= self.wtree.get_widget("cancelButton")

        dic = {
            "on_screensaverIsLauched_toggled" : self.handle_button_toggeled,
            "on_userLogsOff_toggled" : self.handle_button_toggeled,
            "on_enterSuspend_toggled" : self.handle_button_toggeled,
            "on_bgstart_toggled" : self.handle_button_toggeled,
            "on_okButton_clicked" : self.handle_ok_clicked,
            "on_cancelButton_clicked" : self.handle_close_clicked,
            "on_close_clicked" : self.handle_close_clicked,
            "on_propertiesWindow_destroy_event": self.handle_close_clicked,
            "on_suid_rights_toggled" : self.handle_button_toggeled,
            "on_activeHistory_toggled": self.handle_button_toggeled
           }
        self.wtree.signal_autoconnect(dic)
        self.window.show_all()
    
    def handle_close_clicked(self, w):
        self.isvisible= False
        self.window.hide()

    def handle_ok_clicked(self, w):
        self.conf.set(config.AFTER_MOUNT_COMMAND, self.openCommands.get_text())
        self.isvisible= False
        self.window.hide()

    def handle_button_toggeled(self, widget):
        "Toggle internal value state for given widget"
        wname = widget.get_name()
        
        if wname == "screensaverIsLaunched":
            self.conf.set(config.DISMOUNT_ON_SCREENSAVER, widget.get_active())
        elif wname == "userLogsOff":
            self.conf.set(config.DISMOUNT_ON_LOGOFF,  widget.get_active())
        elif wname == "enterSuspend":
            self.conf.set(config.DISMOUNT_ON_SUSPEND,  widget.get_active())
            util.dismountOnSuspend(widget.get_active())
        elif wname == "suid_rights":
            util.fix_suid_43a(widget.get_active())
        elif wname == "bgstart":
            self.conf.set(config.BACKGROUND, widget.get_active())
        elif wname == "activeHistory":
            self.conf.set(config.CACHE_HISTORY, widget.get_active())
            
    def show(self):
        self.visible= True
        self.window.show()
        
    def hide(self):
        self.visible= False
        self.window.hide()
        
    def isvisible(self):
        return self.visible
        
if __name__ == "__main__":
    hwg = Properties()
    gtk.main()