""" UTILITY FUNCTIONS FOR THE GUI"""
import __builtin__, gettext
__builtin__._ = gettext.gettext
				
import gtk, util, threading, string, config, popup, gnomevfs
import utilRevelation, truecryptResponse
import commands, re

TARGETS = [
		  ('MY_TREE_MODEL_ROW', gtk.TARGET_SAME_WIDGET, 0),
		  ('text/plain', 0, 1),
		  ('TEXT', 0, 2),
		  ('STRING', 0, 3),
		  ]

STOCK_TRUECRYPT = "forcefield"

#THIS IS NOT SO GOOD
ICON_PATH = config.DIR_ICONS+"/hicolor/24x24/apps/"+STOCK_TRUECRYPT+".png"

def overwriteFile(file):
	result= popup.Popup(_("Do you want to overwrite the file ")+file+_(" ?"), popup.Popup.CANCEL, title=_("File exists")).run()
	if result != gtk.RESPONSE_OK:
		return False
	return True

def get_gksu_password(message):
	result, p= PasswordDialog("Get sudo password", message).run()
	if result != gtk.RESPONSE_OK:
		result = False
	return result, p
		
def get_list_of_treemodel(treemodel):
		"Builds a list of the treemodel values"
		
		listi = []
		_iter = treemodel.get_iter_first()
		while _iter != None:
			listi += [treemodel.get_value(_iter, 0)]
			_iter = treemodel.iter_next(_iter)
		return listi  
def drag_data_received_data(treeview, context, x, y, selection,
							info, etime):
	model = treeview.get_model()
	
	xdata = selection.data.strip().split()
	
	
	for ydata in xdata:
		data= util.get_filepath_from_uri(ydata)
		
		if data != None:	
			drop_info = treeview.get_dest_row_at_pos(x, y)
			if drop_info:
				path, position = drop_info
				iter = model.get_iter(path)
				if (position == gtk.TREE_VIEW_DROP_BEFORE
					or position == gtk.TREE_VIEW_DROP_INTO_OR_BEFORE):
					model.insert_before(iter, [data])
				else:
					model.insert_after(iter, [data])
			else:
				model.append([data])
			
	if context.action == gtk.gdk.ACTION_MOVE:
		context.finish(True, True, etime)
	return

def drag_data_get_data( treeview, context, selection, target_id,
					   etime):
	treeselection = treeview.get_selection()
	model, iter = treeselection.get_selected()
	data = model.get_value(iter, 0)
	selection.set(selection.target, 8, data)

class ProgressBar:  
		alive=True
		def __init__(self):
			self.window = gtk.Window()
			self.window.set_icon_from_file(ICON_PATH)
			self.window.set_gravity(gtk.gdk.GRAVITY_CENTER)
			self.window.set_position(gtk.WIN_POS_CENTER)
			self.window.set_default_size(500, 100)
			self.window.set_title(_("Move mouse to gain random data"))
			self.progressbar = gtk.ProgressBar()
			self.progressbar.set_text(_("Move mouse to gain random data"))
			
			self.window.add(self.progressbar)
			self.window.connect('destroy', self.exit)
			self.progressbar.set_fraction(0.0)

				
		def run(self):
			self.progressbar.show()
			self.window.show_all()
			while gtk.events_pending():
				gtk.main_iteration()
			
		def exit(self, obj):
			"""Exit callback"""
			self.window.destroy()
			self.alive= False
			return False
		
		def update(self, percent= None):
			percent_float= string.atof(percent)/100
			   
			if percent == None:
				self.progressbar.set_fraction(self.progressbar.get_fraction()+0.01) 
				self.progressbar.set_text(_("Move mouse to create random data: ")+percent+_("% done"))
			else: 
				self.progressbar.set_fraction(percent_float)	  
				self.progressbar.set_text(_("Move mouse to create random data: ")+percent+_("% done"))
				if percent == '100':
					self.window.destroy()
					return True
					
			while gtk.events_pending():
				gtk.main_iteration()
			return self.alive

class EnterChars:
	def __init__(self):

	   self.gladefile=config.DIR_UI+"/enter_chars.glade"
	   self.wtree=gtk.glade.XML(self.gladefile)
	   self.window = self.wtree.get_widget("dialog1")
	   self.window.set_icon_from_file(ICON_PATH)
	   self.text= self.wtree.get_widget("textview1")
	   self.count= self.wtree.get_widget("label3")
	   self.eventbox= self.wtree.get_widget("eventbox1")
	   self.window.set_icon_from_file(ICON_PATH)	  
	   dic = {
	   "on_textview1_insert_at_cursor" : self.modified,
	   "on_textview1_backspace"		: self.modified,
	   "on_textview1_delete_from_cursor" : self.modified,
	   "on_textview1_key_press_event" : self.modified,
	   "on_textview1_paste_clipboard" : self.modified,
	   "on_textview1_cut_clipboard"   : self.modified
	   }
	   

	   self.wtree.signal_autoconnect(dic)
	   green= 0
	   red= 65535
	   self.eventbox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.Color(red, green , 0 ,0))
   
	def modified(self, w=None, b=None, c=None):
	   count= self.text.get_buffer().get_char_count()
	   
	   bounds= self.text.get_buffer().get_bounds()
	   chars=  self.text.get_buffer().get_text(bounds[0],bounds[1])
	   chars=  chars[0:320]	   
	   try:
		   utilRevelation.check_password(chars)
		
	   except ValueError, reason:
		   self.char_check= _('The chars are %s') % str(reason)
	   else:
		   self.char_check= _('The chars seem varied well')
		   
	   green= (65535 / 320) * count
	   red= 65535-green
	   
	   if count < 320:
		   self.count.set_text(`count`+_(" Characters entered")+" / "+self.char_check)
		   self.eventbox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.Color(red, green , 0 ,0))
	   elif count > 700:
		   self.count.set_text(`count`+_(" Characters entered, are you bored? More characters won't help!"))
		   self.eventbox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.Color(0, 65535 , 0 ,0))
	   else:
		   self.count.set_text(`count`+_(" Character entered, ok thats all")+" / "+self.char_check)
		   self.eventbox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.Color(0, 65535 , 0 ,0))
	   
	def run(self):
	   self.result= self.window.run()
	   bounds= self.text.get_buffer().get_bounds()
	   self.chars= self.text.get_buffer().get_text(bounds[0],bounds[1])
	   self.chars= self.chars[0:320]
	   self.window.destroy()
	   return self.result, self.chars

def enterchars():
	enter= EnterChars()
	return enter.run()

class PasswordDialog(threading.Thread):
	def __init__(self, title, dialogText):
		self.gladefile=config.DIR_UI+"/password.glade" 
		self.wtree=gtk.glade.XML(self.gladefile)
		self.window = self.wtree.get_widget("dialog1")
		self.window.set_icon_from_file(ICON_PATH)
		self.password= self.wtree.get_widget("entry1")
		self.window.set_title(title)
		self.wtree.get_widget('label1').set_text(dialogText)
		dic = {
		"on_checkbutton1_toggled" : self.toggle_password,
		}
		self.wtree.signal_autoconnect(dic)
		
		
	def toggle_password(self, w):
		self.password.set_visibility(not self.password.get_visibility())
	
	def run(self):				 
				self.result= self.window.run()
				self.passw= self.password.get_text()

				self.window.destroy()
				return self.result, self.passw

class Mount_Point_Dialog(threading.Thread):
	def __init__(self, default_mountpoint=""):
		self.gladefile=config.DIR_UI+"/mount_point.glade" 
		self.wtree=gtk.glade.XML(self.gladefile)
		self.window = self.wtree.get_widget("dialog1")
		self.window.set_icon_from_file(ICON_PATH)
		self.mount_point= self.wtree.get_widget("mount_point")
		self.window.set_title("Enter mountpoint")
		self.mount_point.set_text(default_mountpoint)
		
	def run(self):				 
				self.result= self.window.run()
				self.mp= self.mount_point.get_text()

				self.window.destroy()
				return self.result, self.mp

class KeyfilesChooser(threading.Thread):
	def __init__(self, choosePath= False):
		if choosePath: 
			action = gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER
		else:
			action = gtk.FILE_CHOOSER_ACTION_OPEN
		self.dialog = gtk.FileChooserDialog("Open..",
									   None,
									   action,
									   (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
										gtk.STOCK_OPEN, gtk.RESPONSE_OK))
		self.dialog.set_default_response(gtk.RESPONSE_OK)
		
		filter = gtk.FileFilter()
		filter.set_name("All files")
		filter.add_pattern("*")
		self.dialog.add_filter(filter)

	def run(self):
		response = self.dialog.run()
		filename= self.dialog.get_filename()
		self.dialog.destroy()
		return filename, response

class EnterKeyfiles:
	def __init__(self):
		self.gladefile=config.DIR_UI+"/enterkeyfiles.glade" 
		
		self.wtree=gtk.glade.XML(self.gladefile)
		
	def clear_all(self, b):
		"Clears the all the keyfiles"
		gtk.ListStore.clear(self.liststore)
	
	
	def clear_selected(self, button):
		"Clears the selected keyfile"
		selection = self.treeview.get_selection()
		model, selected = selection.get_selected_rows()
		iters = [model.get_iter(path) for path in selected]
		for iter in iters:
			model.remove(iter)
	
	def keyfiles_chooser(self, w):
		choosePath= False
		if w.get_name() == "add_path":
			choosePath=True
		keyfile, response= KeyfilesChooser(choosePath).run()
		if response != gtk.RESPONSE_CANCEL:
			self.treeview.get_model().append([keyfile])
			
	def run(self):
		self.window = self.wtree.get_widget("dialog1")
		self.window.set_icon_from_file(ICON_PATH)
		self.wfiles = self.wtree.get_widget("keyfiles")
		
		self.liststore = gtk.ListStore(str)
		self.treeview= self.wfiles
		self.treeview.get_selection().set_mode(gtk.SELECTION_MULTIPLE)
		self.treeview.set_model(self.liststore)
		self.cell = gtk.CellRendererText()

		# create the TreeViewColumns to display the data
		self.tvcolumn = gtk.TreeViewColumn('File', self.cell, text=0)

		# add columns to treeview
		self.treeview.append_column(self.tvcolumn)
		self.treeview.set_search_column(0)

		# Allow sorting on the column
		self.tvcolumn.set_sort_column_id(0)

		# Allow enable drag and drop of rows including row move
		self.treeview.enable_model_drag_source( gtk.gdk.BUTTON1_MASK,
												TARGETS,
												gtk.gdk.ACTION_DEFAULT|
												gtk.gdk.ACTION_MOVE)
		self.treeview.enable_model_drag_dest(TARGETS,
											 gtk.gdk.ACTION_DEFAULT)
		
		dic = {
		   "on_keyfiles_drag_data_received" : drag_data_received_data,
		   "on_keyfiles_drag_data_get" : drag_data_get_data,
		   "on_add_keyfile_clicked" : self.keyfiles_chooser,
		   "on_remove_selected_clicked" : self.clear_selected,
		   "on_add_path_clicked" : self.keyfiles_chooser,
		   "on_remove_all_clicked": self.clear_all,
		   }
		self.wtree.signal_autoconnect(dic)
		
		self.result= self.window.run()
		
		self.window.destroy()
		return self.result, self.liststore		   

	
	
def register_truecrypt_icons():
	register_stock_item(config.DIR_ICONS+"/hicolor/24x24/apps/"+STOCK_TRUECRYPT+".png", STOCK_TRUECRYPT)

def register_stock_item(filename, name):	
	factory = gtk.IconFactory()
	pixbuf = gtk.gdk.pixbuf_new_from_file(filename)
	iconset = gtk.IconSet(pixbuf)
	factory.add(name, iconset)
	factory.add_default()
	
class About(gtk.AboutDialog):
	"About dialog"
	def __init__(self, parent):
		gtk.AboutDialog.__init__(self)

		if isinstance(parent, gtk.Window):
			self.set_transient_for(parent)
		gtk.about_dialog_set_email_hook(self.on_email)
		gtk.about_dialog_set_url_hook(self.on_url)
		self.set_name(config.APPNAME)
		self.set_version(config.VERSION)
		self.set_copyright(config.COPYRIGHT)
		self.set_comments(('"%s"\n\n' + _("truecrypt frontend for gnome")) % config.RELNAME)
		self.set_license(config.LICENSE)
		self.set_website(config.URL)
		self.set_website_label(config.URL)
		self.set_authors(config.AUTHORS)
		self.set_logo( gtk.gdk.pixbuf_new_from_file(ICON_PATH))
		self.set_artists(config.ARTISTS)


	def on_email(self, about, mail):
	     gnomevfs.url_show("mailto:%s" % mail)
	def on_url(self, about, link):
	     gnomevfs.url_show(link)
	     
	def run(self):
		"Displays the dialog"

		self.show_all()
		gtk.AboutDialog.run(self)

		self.destroy()
