""" HERE ARE UTILITY FUNCTIONS """
import urllib, commands, config, popup, os, uiutil, texpect, truecryptResponse

def if_else(condition, trueval, falseval):
    "execute conditional"
    if condition:
        return trueval
    else:
        return falseval


def if_else_bool(condition):
    "if else bool"
    return if_else(condition==True, True, False)

  
def get_filepath_from_uri(uri):
    "get the file path from the dropped uri"
    if uri == None:
        return None
    path = urllib.url2pathname(uri) # escape special chars
    path = path.strip('\r\n\x00') # remove \r\n and NULL

    # get the path to file
    if path.startswith('file:\\\\\\'): # windows
        path = path[8:] # 8 is len('file:///')
    elif path.startswith('file://'): # nautilus, rox
        path = path[7:] # 7 is len('file://')
    elif path.startswith('file:'): # xffm
        path = path[5:] # 5 is len('file:')
    elif path.startswith('x-nautilus-desktop'):
        path = None
    return path

def get_version(command):
    return commands.getoutput(command+" -V").split('\n')[0].split(" ")[1]

def get_full_binary_path(command):
    "get fullpath for binary name: a whereis"
    #returns -1 if path was not found
    output = commands.getoutput("whereis -b "+command).split()
    if output[1] == "":
        return -1
    return output[1]# nr one of the array is the binary path

def fix_suid_43a(fixOrRemove):
    "fixOrRemove is true to fix and false for remove"
    conf = config.Config()
    command = conf.get('command')

    tgroup = "truecrypt"
    username = commands.getoutput("whoami")
    sudoers = "/etc/sudoers"
    conf = config.Config()

    
    if fixOrRemove:

        coms= ["groupadd "+tgroup,
               "adduser "+username+" "+tgroup,
               "patch -r /tmp/sudoers.rej "+config.SUDOERS_FILE+" "+config.SUDOERS_PATCH
               ]
        for c in coms:
            tc= texpect.Texpect()
            result= tc.doSudoCommand(c,
                             uiutil.get_gksu_password,
                             _("Get sudo password to add group")+ tgroup+_(", add the user ")+username+_("to this group. And patch /etc/sudoers")
                             ) == truecryptResponse.TRY_AGAIN
            if result:
                conf.set(config.SUPPRESS_SUID_WARNING, True)
                
            elif result== truecryptResponse.TRY_AGAIN:
                popup.Popup(_("Wrong password"))
                return
    else:

        coms= ["delgroup "+username+" "+tgroup,
               "delgroup "+tgroup,
               "patch -r /tmp/sudoers.rej "+config.SUDOERS_FILE+" "+config.SUDOERS_UNPATCH
               ]
        for c in coms:
            tc= texpect.Texpect()
            result= tc.doSudoCommand(c,
                             uiutil.get_gksu_password,
                             _("Get sudo password to remove "+tgroup+_(", remove the user ")+username+_("to this group. And remove patch from /etc/sudoers"))
                             ) == truecryptResponse.TRY_AGAIN
            if result:         
                conf.set(config.SUPPRESS_SUID_WARNING, False)
            elif result== truecryptResponse.TRY_AGAIN:
                popup.Popup(_("Wrong password"))
                return
    return True

def userInForcefieldGroup():
    loginname= commands.getoutput("whoami")
    result= commands.getoutput("groups "+loginname)
    groups= result.split(" ")
    if 'truecrypt' in groups:
        return True
    else:
        return False

def createMountPoint(path):
    if os.path.exists(path):
        return True
    tc= texpect.Texpect()
    result = tc.doSudoCommand("mkdir "+path, uiutil.get_gksu_password, _("Mountpoint does not exist. Enter sudo password to create or click cancel to abort")+path
                        )
    if result == truecryptResponse.TRY_AGAIN:
        popup.Popup(_("Wrong password"))
        return False
    elif result == truecryptResponse.CANCELED:
        return truecryptResponse.CANCELED
    elif result == False:
        return truecryptResponse.CANCELED
    return True
    
def dismountOnSuspend(activate):
    "if activate is True patch will be applied if not patch will be removed"
    "this function may cause if repeatly called with True the patch to be applied multiple"
    "times so that logic has to be implemented outside of this function"
    if not os.path.exists(config.ACPI_SLEEP_HOOK_SCRIPT):
        return False

    if activate:
        tc= texpect.Texpect()

        if tc.doSudoCommand("patch "+config.ACPI_SLEEP_HOOK_SCRIPT+" "+config.DISMOUNT_ON_SUSPEND_PATCH,
                         uiutil.get_gksu_password,
                         _("Get sudo password to apply patch to /etc/acpi/sleep.sh")
                         ) == truecryptResponse.TRY_AGAIN:             
            popup.Popup(_("Wrong password"))
    else:
        tc= texpect.Texpect()
        if tc.doSudoCommand("patch -r /tmp/sleep.sh.rej "+config.ACPI_SLEEP_HOOK_SCRIPT+" "+config.NOT_DISMOUNT_ON_SUSPEND_PATCH,
                         uiutil.get_gksu_password,
                         _("Get sudo password to apply patch to /etc/acpi/sleep.sh")
                         ) == truecryptResponse.TRY_AGAIN:
            popup.Popup(_("Wrong password"))       


    return True