#!/usr/bin/python
########################################
# @author: Oliver Ripka
# @date: 03.07.2007
########################################
import sys, os, stat, commands, string, dbus, gobject, getopt, pygtk

pygtk.require("2.0")
import gtk

if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
    import dbus.glib

import sys
from os.path import dirname, join, pardir

if "@pyexecdir@/forcefield" not in sys.path:
        sys.path.insert(1, "@pyexecdir@/forcefield")
        sys.path.insert(2, join(dirname(__file__), pardir, 'lib'))

#GETTEXT STUFF
from gtk import glade
import gettext
import locale
LOCALE_PATH = "/usr/share/locale"
#LOCALE_PATH = "@datadir@/locale"
GETTEXT_DOMAIN = 'forcefield'
locale.setlocale(locale.LC_ALL, '')
for module in glade, gettext:
    module.bindtextdomain(GETTEXT_DOMAIN, LOCALE_PATH)
    module.textdomain(GETTEXT_DOMAIN)

# register the gettext function for the whole interpreter as "_"
import __builtin__
__builtin__._ = gettext.gettext

#OWN IMPORTS
import config

import popup, truecryptResponse
import volumes, volume
import util, uiutil
import dialogMount, dialogList, dialogCreate, dialogProperties

try:
    import pynotify
    pynotify.init(config.APPNAME)
    NOTES_PRESENT= True
           
except:
    NOTES_PRESENT= False 
    print _("You don't seem to have pynotify installed. ")

class TApplet:
    DEBUG= False
    mountdialog= None
    statusIcon= None
    volumes_obj= volumes.Volumes(uiutil.get_gksu_password)
    
    volumes_were_dismounted = False
    
################################################################################
#    pwr_statistics_event_map = {"0": "GPM_EVENT_ON_AC",
#           "1": "GPM_EVENT_ON_BATTERY",
#           "2": "GPM_EVENT_SESSION_POWERSAVE",
#           "3": "GPM_EVENT_SESSION_IDLE",
#           "4": "GPM_EVENT_SESSION_ACTIVE",
#           "5": "GPM_EVENT_SUSPEND",
#           "6": "GPM_EVENT_HIBERNATE",
#           "7": "GPM_EVENT_RESUME",
#           "8": "GPM_EVENT_LID_CLOSED",
#           "9": "GPM_EVENT_LID_OPENED",
#           "10": "GPM_EVENT_NOTIFICATION",
#           "11": "GPM_EVENT_DPMS_ON",
#           "12": "GPM_EVENT_DPMS_STANDBY",
#           "13": "GPM_EVENT_DPMS_SUSPEND",
#           "14": "GPM_EVENT_DPMS_OFF",
#           "15": "GPM_EVENT_LAST"}    
################################################################################
    
    def __init__(self, debug=False):
        self.DEBUG= debug

    
        #INIT DBUS STUFF 
        try:
            systembus = dbus.SystemBus()
            
            #halmanager
            self.hal_manager_obj = systembus.get_object('org.freedesktop.Hal', '/org/freedesktop/Hal/Manager')
            self.hal_manager = dbus.Interface(self.hal_manager_obj, 'org.freedesktop.Hal.Manager')
            
            self.hal_manager.connect_to_signal('DeviceAdded', lambda *args:  self.device_added_callback( *args))
            self.hal_manager.connect_to_signal('DeviceRemoved',lambda *args:  self.device_removed_callback( *args))
        except:
            ""

        #screensaver
        try:
            sessionbus = dbus.SessionBus()
            self.screensaver_obj = sessionbus.get_object('org.gnome.ScreenSaver', '/org/gnome/ScreenSaver')
            self.screensaver= dbus.Interface(self.screensaver_obj, 'org.gnome.ScreenSaver')
            
            self.screensaver.connect_to_signal("ActiveChanged", lambda *args: self.screensaver_event_callback(*args))
        except:
            try:
                self.screensaver_obj = sessionbus.get_object('org.freedesktop.ScreenSaver', '/org/freedesktop/ScreenSaver')
                self.screensaver= dbus.Interface(self.screensaver_obj, 'org.freedesktop.ScreenSaver')
                self.screensaver.connect_to_signal("ActiveChanged", lambda *args: self.screensaver_event_callback(*args))
            except:
                print "no screensaver available over dbus"
        #END
        
        
        
        #CONFIG
        self.conf = config.Config()
        try:
            output = commands.getoutput("whereis -b truecrypt").split()
            if output[1] == "": exit(1)
            self.conf.set(config.COMMAND, output[1])
        except:
            print _("You don't have truecrypt installed please install it")
            
            exit(1)
        
        
        for option in config.OPTIONS:
             try:
                self.conf.get(option) #This should exist if schemad were installed
             except:
                output, status= config.install_schema("%s/forcefield.schemas" % config.DIR_GCONFSCHEMAS)
                if not status: exit
        #END
        
        #MAKE STATUS ICON
        menu_items = (
        (_("Create Volume"), self.createDialogProxy, gtk.image_new_from_stock(gtk.STOCK_NEW, gtk.ICON_SIZE_MENU) ),
        (_("Mount File"), self.mountDialogProxy, gtk.image_new_from_stock(gtk.STOCK_DIRECTORY, gtk.ICON_SIZE_MENU) ),
        (_("List Mounted"), self.listDialogProxy, gtk.image_new_from_stock(gtk.STOCK_HARDDISK, gtk.ICON_SIZE_MENU) ),
        (_("Clear History"), self.clearHistory, gtk.image_new_from_stock(gtk.STOCK_CLEAR, gtk.ICON_SIZE_MENU) ),
        (_("Dismount all"), self.dismountAllProxy, gtk.image_new_from_stock(gtk.STOCK_MEDIA_RECORD, gtk.ICON_SIZE_MENU)),
        (_("Properties"), self.propertiesDialogProxy, gtk.image_new_from_stock(gtk.STOCK_PROPERTIES, gtk.ICON_SIZE_MENU)),
        (_("About"), self.about, gtk.image_new_from_stock(gtk.STOCK_ABOUT, gtk.ICON_SIZE_MENU)),
        (_("Close"), self.exit_applet, gtk.image_new_from_stock(gtk.STOCK_QUIT, gtk.ICON_SIZE_MENU))
        );
        
        
        menu = gtk.Menu()

        for i in menu_items:
            if i is None:
                menu.add(gtk.SeparatorMenuItem());
            else:
                menu_items = gtk.ImageMenuItem(i[0])#i[0]
                menu_items.set_image(i[2])
                      
                menu_items.connect( 'activate', i[1] );
                menu.add( menu_items );
        
        
        menu.show_all()
        self.menu= menu
        
        statusIcon = gtk.StatusIcon()
        statusIcon.set_from_file(uiutil.ICON_PATH)
        
        statusIcon.connect('popup-menu', self.applet_face_click, menu)
        statusIcon.connect('activate', self.activate)
        #END
        self.statusIcon=statusIcon

        if not self.conf.get(config.SUPPRESS_SUID_WARNING):
            popup.Popup(_("Forcefield above version 4.3 needs you to enter the su password for _every_ operation.\nOne can avoid that by adding a group \"truecrypt\", adding the current user to that group\nand editing \"/etc/sudoers\". This programm can do this for you. Be aware that this may be\na security risk! So users might be able to exploit truecrypt to get superuser rights on you system\n"),
            "Suppress further warnings", "suppressSuidWarning"
            )

        mounted= self.mountedVolumes()
        
        
        if not self.conf.get(config.BACKGROUND):
            self.tlist= dialogList.TruecryptList(self, mounted)
            
        self.scan_devices(mounted)
    
    def about(self, n=None):
        a= uiutil.About(self)
        a.run()
    
    def exit_applet(self, *args ):
        gtk.main_quit();
        return;

    def activate(self, status_icon, data=None):
        self.toggleListWindow()
        
    def applet_face_click(self, widget, button, time=None, data=None ):
        if button == 3 :
            self.menu.popup( None, None, None, 0, time );
            
        elif button == 1 :
            self.toggleListWindow()
        return
    
    #LIST DIALOG
    
    def listDialogProxy(self, w):
        try: 
            if self.tlist == None:
                raise
            else:
                self.tlist.show()
                return True
        except:  
            self.tlist= dialogList.TruecryptList(self)
            self.tlist.show()
            return False
        
    def toggleListWindow(self):
        try:
            if self.tlist == None:
                raise
            if not self.tlist.isvisible():
                self.tlist.show()
                return False
            else:
                self.tlist.hide()
                return False
        except:
            self.tlist= dialogList.TruecryptList(self)
            self.tlist.show()
            return True
    
    #MOUNT DIALOG
    
    def mountDialogProxy(self, w=None):

        if self.mountdialog == None:
            self.mountdialog= dialogMount.Mount(self)
            self.mountdialog.show() 
            return
        if not self.mountdialog.isvisible():
            self.mountdialog= dialogMount.Mount(self)
            self.mountdialog.show()
        else:
            ""     
    
    def mountaction(self, dev, *args):
        n = args[0]
        action = args[1]
        assert action == "mount"
        if self.mountdialog == None:
            self.mountdialog= dialogMount.Mount(self, dev, None)
        #self.mountdialog.set_volume(dev)
        
        if not self.mountdialog.isvisible():
            self.mountdialog.show()  

    #CREATE DIALOG
            
    def createDialogProxy(self, w=None):
        dialogCreate.CreateVolume(self)
        
    def clearHistory(self, w=None):
        try:
            self.mountdialog.clear_history()
        except:
            ""
        
        self.conf.clear_mount_history()
        result = self.volumes_obj.refresh()


    #DISMOUNT ALL
    def dismountAllProxy(self, w):
        result= TApplet.volumes_obj.dismount_all()
        
        self.refreshList()
        
        if result == truecryptResponse.DISMOUNTING_SUCCESSFULL:
            popup.Popup(_("Dismounting successful!"))
        elif result == truecryptResponse.TRY_AGAIN:
            popup.Popup(_("Wrong sudo password"))
        elif result == truecryptResponse.CANCELED:
            return 
        elif result == truecryptResponse.NO_VOLUMES_MAPPED:
            popup.Popup(_("No volumes mapped"))
        elif result == truecryptResponse.DEVICE_BUSY:
            popup.Popup(_("Some device could not be dismounted, device busy"))
            

    #PROPERTIES PROXY
    def propertiesDialogProxy(self, w=None):
        dialogProperties.Properties(self)
    
    def refreshList(self):
        self.toggleListWindow()
        self.tlist.refreshVolumeList()
        
    def notifyUserOfVolume(self, addedOrRemoved, dev):
        if NOTES_PRESENT:
           status = (" removed"," added")[addedOrRemoved==True]
           self.n = pynotify.Notification(_("Device ")+dev+status , _("A device which is possibly a truecrypt volume was")+status, uiutil.ICON_PATH)
            
           self.n.set_category("device")
           
           self.n.add_action("mount", "Mount", lambda *args: self.mountaction( dev, *args))

           if not self.n.show():
             ""
    
        else:
           "make a popup"
           
    def device_added_callback(self, *args):
        udi = self.hal_manager.FindDeviceStringMatch('info.udi', args[0])[0]
        try:
            device= TApplet.volumes_obj.by_udi(udi)
        except:
            return False
        
        if device == False:
            device= volume.Volume(udi=udi)
        
        if device.is_a_truecrypt_device() and not device.isMounted():
            self.notifyUserOfVolume(True, device.volume_path)
    
    def device_removed_callback(self, *args):
        udis= args[0]
        
    def suspend_event_callback(self, *args):
        print "system is going to suspend"
        if self.conf.get(config.DISMOUNT_ALL_ON_SUSPEND):
            self.volumes_obj.dismount_all()

    def screensaver_event_callback(self, *args):
        activated = args[0]
        
        if activated == True and self.conf.get(config.DISMOUNT_ON_SCREENSAVER):
            
            if self.volumes_obj.get_all_mapped_volumes() != []:
                self.volumes_were_dismounted = True
            else:
                self.volumes_were_dismounted = False
            self.volumes_obj.dismount_all()
        elif activated== False and self.conf.get(config.DISMOUNT_ON_SCREENSAVER):
            if self.volumes_were_dismounted == True:
                self.tlist.refreshVolumeList()
                self.n = pynotify.Notification(_("Screensaver was activated"),_("All volumes were dismounted"), uiutil.ICON_PATH)
                self.n.set_category("device")
                self.n.show()

        
    def mountedVolumes(self):
        result = TApplet.volumes_obj.refresh()
        if result == truecryptResponse.TRY_AGAIN:
            popup.Popup(_("Need sudo password to refresh volume list"))
        
        if TApplet.volumes_obj.num_volumes_mapped() == 0:
            return []
        
        mounts= []
        for volume in TApplet.volumes_obj.get_all_mapped_volumes():
            if not volume.isMounted():
                mounts+= [[volume.volume_path, _("Volume is not mounted")]]
            else:
                mounts+= [[volume.volume_path, volume.mount_point]]

        return mounts
    
    def scan_devices(self, mounted= None):
        num_tc_volume= 0
        udi_list = self.hal_manager.FindDeviceStringMatch('volume.fstype', '')
        for udi in udi_list:
            vol= TApplet.volumes_obj.by_udi(udi)
            if vol == False:
                vol= volume.Volume(udi=udi)
                
            if vol != False and vol.is_a_truecrypt_device() and not vol.isMounted():
                self.notifyUserOfVolume(True, vol.volume_path)
                

def usage_exit(progname, msg=None):
    if msg:
        print msg
        print
    print "usage: %s -d|--debug (true|false)" % progname
    sys.exit(2)

if __name__ == "__main__":
    debug= False
    try:
        opts, args = getopt.getopt(sys.argv[1:], 'd', ['help','debug'])
         
        for opt, value in opts:
            if opt in ('-h','--help'):
                usage_exit(config.APPNAME)
            if opt in ('-d','--debug'):
                debug= True
                config.DEBUG= True
    except getopt.error, e:
            usage_exit(config.APPNAME, e)
            
    hwg = TApplet(debug)
    gtk.main() 